<template>
	<view class="color-333 u-font-28">
		<up-sticky :offset-top="0">
			<view class=" bg-fff u-flex u-p-l-30 u-row-between">
				<view class="u-flex  ">
					<view class="u-flex u-p-t-30 u-p-b-30 u-flex-1 u-row-center" @tap="timeToggle">
						<text class="u-m-r-12 no-wrap" :class="{'color-main':filters.time.start&&filters.time.end}">筛选时间</text>
						<image src="/pageProduct/static/images/icon-arrow-down-fill.svg" class="icon-arrow-down-fill"
							mode="">
						</image>
					</view>
					<view class="u-flex u-m-l-60 u-p-t-30 u-p-b-30  u-flex-1 u-row-center" @tap="showTypesToggle">
						<text class="u-m-r-12" v-if="types.active===''"> 选择类型</text>
						<text class="u-m-r-12 no-wrap color-main" v-else>{{types.list[types.active].text}}</text>
						<image src="/pageProduct/static/images/icon-arrow-down-fill.svg" class="icon-arrow-down-fill"
							mode="">
						</image>
					</view>
				</view>
			
				<view :style="{height:types.show?typesHeight:0}" class="tranistion types overflow-hide">
					<view @tap="changeTypesActive(index)" class="u-flex u-p-l-30 lh30 u-p-r-30 u-row-between"
						v-for="(item,index) in types.list" :key="index">
						<view>{{item.text}}</view>
						<uni-icons v-if="types.active===index" type="checkmarkempty" :color="color.ColorMain"></uni-icons>
					</view>
					<view :style="{height: types.bottomHeight+'px'}"></view>
				</view>
			</view>
		</up-sticky>
		

		<view class=" min-page bg-gray list u-p-30">
			<view class="u-flex u-m-b-30" v-if="filters.time.start&&filters.time.end">
				<view class="time-area u-font-24 color-main u-flex">
					<uni-dateformat format="yyyy-MM-dd hh:mm:ss" :date="filters.time.start"></uni-dateformat>
					<text class="u-p-l-10 u-p-r-10">至</text>
					<uni-dateformat format="yyyy-MM-dd hh:mm:ss" :date="filters.time.end"></uni-dateformat>
					<view class="u-m-l-10 u-flex" @tap="clearTime">
						<uni-icons type="clear" size="18" :color="color.ColorMain"></uni-icons>
					</view>
				</view>
			</view>

			<!-- <view class="recoreds color-fff ">
				<view class="u-font-32">详情记录</view>
				<view class="u-flex u-row-between u-m-t-48">
					<view class="u-flex u-flex-col u-row-center u-col-center">
						<view>变动数量</view>
						<view class="u-font-32 u-m-t-10 font-bold">{{pageData.changeSum}}</view>
					</view>
				</view>
			</view> -->
			<template v-if="pageData.list.length">
				<view class="u-m-b-28 " v-for="(item,index) in pageData.list" :key="index">
					<my-list-item :data="item" ></my-list-item>
				</view>
				<my-pagination :size="pageData.size" :totalElements="pageData.totalElements"
					@change="pageChange"></my-pagination>
				<!-- <uni-load-more :status="pageData.status" /> -->
			</template>
			<template v-if="pageData.hasAjax&&!pageData.list.length">
				<view class="" style="margin-top: 150rpx;">
					<my-img-empty tips="暂无记录"></my-img-empty>
				</view>
			</template>

		</view>

	<my-date-pickerview @confirm="datePickerConfirm" ref="datePicker" mode="all"></my-date-pickerview>
	<my-mask ref="mask" @close="hideType"></my-mask>
	</view>

</template>

<script setup>
	import {
		onLoad,
		onReady,
		onShow,
		onPageScroll,
		onPullDownRefresh
	} from '@dcloudio/uni-app';
	import color from '@/commons/color';
	import myListItem from './components/list-item.vue';
	import {
		ref,
		reactive,
		computed,
		watch
	} from 'vue';
	import {
		$getProductDetail,
		$getProductStockDetail,$getProductStockDetailSum
	} from '@/http/yskApi/goods.js'
	import {
		$invoicingType
	} from '@/commons/goodsData.js'
	const search = reactive({
		keyword: '',
		show: false
	})

	function searchConfirm() {

	}

	function hideSearch() {
		search.show = false
		maskHide()
	}

	function showSearch() {
		search.show = true
		types.show = false
		maskShow()
	}


	// 库存分类
	const types = reactive({
		list:$invoicingType,
		active: '',
		show: false,
		bottomHeight: 14
	})

	function hideType() {
		types.show = false
		search.show = false
	}
	const typesHeight = computed(() => {
		return 30 * types.list.length + types.bottomHeight + 'px'
	})

	function changeTypesActive(i) {
		types.active = i
		types.show = false
		toggleMask()
	}

	function showTypesToggle() {
		types.show = !types.show
		maskShow()
	}
	
	// 页数改变事件
	function pageChange(page) {
		pageData.query.page=page-1
		init()
	}
	

	const filters = reactive({
		time: {
			start: '',
			end: ''
		}
	})
	
	function resetQuery(){
		pageData.query.page=0
	}
	function clearTime() {
		filters.time.start = ''
		filters.time.end = ''
		resetQuery()
		init()
	}

	const datePicker = ref(null)
	function datePickerConfirm(e) {
		filters.time.start = e.start
		filters.time.end = e.end
		resetQuery()
		init()
	}

	function timeToggle() {
		datePicker.value.toggle()
	}


	const mask = ref(null)

	function toggleMask(show) {
		mask.value.toggle()
	}

	function maskShow() {
		mask.value.open()
	}

	function maskHide() {
		mask.value.close()
	}

	
	const pageData = reactive({
		query: {
			page: 0,
			size: 10,
			productId:'',
			column:'/api/tbProductStockDetail/stock/count',
			shopId:uni.getStorageSync('shopId'),
			createdAt:[]
		},
		totalElements: 0,
		list: [],
		status: 'noMore',
		hasAjax:false,
		changeSum:0
	})
	async function init() {
		const createdAt=(filters.time.start&&filters.time.end)?[filters.time.start,filters.time.end ]:[]
		const res = await $getProductStockDetail({
			...pageData.query,
			type:types.active!==''?types.list[types.active].value:'',
			createdAt
		})
		pageData.hasAjax=true
		pageData.list = res.content
		pageData.totalElements = res.totalElements
	}
	async function getSum(){
		const res = await $getProductStockDetailSum({
			productId: pageData.query.productId
		})
		pageData.changeSum = res.exchange
	}
	watch(()=>types.active,(newval)=>{
		resetQuery()
		init()
	})
	
	onLoad(opt => {
		console.log(opt);
		Object.assign(pageData.query,opt)
		init()
		// getSum()
	})
</script>

<style lang="scss" scoped>
	.fixed-top {
		z-index: 10;
	}

	.recoreds {
		background: linear-gradient(127deg, #33A0FF 0%, #6699FF 100%);
		box-shadow: 0rpx 20rpx 60rpx 2rpx rgba(92, 112, 248, 0.2);
		border-radius: 14rpx 14rpx 14rpx 14rpx;
		padding: 32rpx 40rpx 40rpx 48rpx;
		position: relative;
		overflow: hidden;

		&::after {
			content: '';
			top: -112rpx;
			border-radius: 50%;
			display: block;
			position: absolute;
			right: 56rpx;
			width: 224rpx;
			box-shadow: 0 0 1px #666;
			height: 224rpx;
			background: linear-gradient(180deg, rgba(103, 204, 254, 0.6) 0%, rgba(144, 87, 255, 0) 100%);
		}
	}

	.search-box {
		background-color: #fff;
		padding: 16rpx 0;
		top: 0;
		bottom: 0;
		position: absolute;
		right: 30rpx;
		display: flex;

		.search-btn {
			padding: 0 30rpx;
			box-sizing: border-box;
			display: flex;
			align-items: center;
			// width: 164rpx;
			transition: all .3s ease-in-out;
			background-color: rgb(247, 247, 247);
			border-radius: 100px;
		}
	}

	.types {
		position: absolute;
		top: 100%;
		left: 0;
		right: 0;
		z-index: 10;
		background-color: #fff;
	}

	.time-area {
		background: #E6F0FF;
		border-radius: 100px;
		padding: 10rpx 20rpx;
	}

	.icon-arrow-down-fill {
		width: 16rpx;
		height: 10rpx;
	}

	.list {
	}
</style>